module Test where

--
-- Test suite for exercise sheet 02.
--

import Data.Char(toLower, isSpace)

import Test.Tasty
import Test.Tasty.HUnit

import Pizza
import Justify

run = defaultMain $ testGroup "All tests" [pizzaTests, justHelpTests, justifyTests]

l1 :: Lager
l1 = L Oliven 3 (L Tomate 3 (L Kaese 4 (L Peperoni 1 Leer))) 

l2 :: Lager
l2 = L Salami 1 (L Kaese 3 (L Tomate 3 (L Schinken 1 (L Ananas 1 Leer))))

b1 :: Bestellung
b1 = (B PMargherita (B PSalami (B PHawai Nichts)))


pizzaTests = testGroup "Tests for Pizza"
  [ testCase "Margherita verfuegbar" $
    pizzaVerfuegbar l1 PMargherita @? "Keine Margherita"
  , testCase "Diavolo nicht verfuegbar" $
    not (pizzaVerfuegbar l1 PDiavolo) @? "Keine Salami"
  , testCase "Bestellung Backen" $
    bestellungBacken l2  b1 @?= Leer
  , testCase "lieferung/backen invers (Quattro)" $
    pizzaBacken (lieferung l1 (zutaten PQuattro)) PQuattro @?= l1 
  , testCase "lieferung/backen invers (Hawai)" $
    pizzaBacken (lieferung l2 (zutaten PHawai)) PHawai @?= l2
  ]

s1 = "Foo! Baz, bar   bar   foo"
line1 = Line "Foo!" (Line "Baz," (Line "bar" (Line "bar" (Line "foo" Empty))))

justHelpTests = testGroup "Tests for justify helpers"
   [ testCase "stringToLine line1" $ stringToLine s1 @?= line1
   , testCase "lineToString s1" $ lineToString line1 @?= "Foo! Baz, bar bar foo"
   , testCase "lineToString invers" $ stringToLine (lineToString line1) @?= line1
   , testCase "numWords line1" $ numWords line1 @?= 5
   , testCase "len line1" $ len line1 @?= 17
   , testCase "formatLine line1" $ formatLine 23 line1 @?= "Foo! Baz, bar  bar  foo"
   ]


txt1 = "Lor em ip sum dol or sit amet, con set et ur ad ip scing  eli tra, sed diam no nu my"

txt1j = "Lor em  ip  sum\ndol   or    sit\namet,  con  set\net  ur  ad   ip\nscing eli  tra,\nsed diam no  nu\nmy"

checkLineLength :: String-> Int-> Bool
checkLineLength s l = all ((l ==) . length) (init (lines s))

checkContent :: String-> String-> Bool
checkContent s1 s2 = filter (not . isSpace) s1 == filter (not . isSpace) s2

justifyTests = testGroup "Tests for justfiy"
   [ testCase "Justify sample text: line length" $
     checkLineLength (justify 15 txt1) 15 @? "Line(s) of wrong length"
   , testCase "Justify sample text: content" $
     checkContent (justify 15 txt1) txt1 @? "Content missing/superfluous"
   , testCase "Justify sample text" $ justify 15 txt1 @?= txt1j
   , testCase "Jusitfy short text" $ justify 20 "Foo bar" @?= "Foo bar"
   ]
